/*
* Copyright © 2019-2022. TIBCO Software Inc.
* This file is subject to the license terms contained
* in the license file that is distributed with this file.
*/
package com.tibco.accelerators.operators.file;

import java.beans.*;

import com.streambase.sb.operator.parameter.*;

public class FileWriterOperatorBeanInfo extends SBSimpleBeanInfo {

	public SBPropertyDescriptor[] getPropertyDescriptorsChecked()
			throws IntrospectionException {
		SBPropertyDescriptor[] p = {
				// Adapter Properties
				new SBPropertyDescriptor("filename", FileWriterOperator.class)
						.displayName("File Name")
						.description("")
						.optional()
						.setUIHints(
								UIHints.create().setTab("Adapter Properties")),
				new EnumPropertyDescriptor("fileDoesntExist", FileWriterOperator.class,
						new String[] { "Create new file", "Fail" })
						.displayName("If File Doesn't Exist")
						.description("")
						.optional()
						.setUIHints(
								UIHints.create().setTab("Adapter Properties")),
				new EnumPropertyDescriptor("fileExists", FileWriterOperator.class,
						new String[] { "Append to existing file",
								"Truncate existing file", "Fail" })
						.displayName("If File Exists")
						.description("")
						.optional()
						.setUIHints(
								UIHints.create().setTab("Adapter Properties")),
				new SBPropertyDescriptor("useDefaultCharset", FileWriterOperator.class)
						.displayName("Use Default Charset")
						.description("")
						.optional()
						.setUIHints(
								UIHints.create().setTab("Adapter Properties")),
				new SBPropertyDescriptor("characterSet", FileWriterOperator.class)
						.displayName("Character Set")
						.description("")
						.optional()
						.setUIHints(
								UIHints.create().setTab("Adapter Properties")),
				new SBPropertyDescriptor("writeAsBinary", FileWriterOperator.class)
						.displayName("Write As Binary")
						.description("")
						.optional()
						.setUIHints(
								UIHints.create().setTab("Adapter Properties")),
				new SBPropertyDescriptor("synchronousWrite", FileWriterOperator.class)
						.displayName("Synchronous Write")
						.description("")
						.optional()
						.setUIHints(
								UIHints.create().setTab("Adapter Properties")),
				new EnumPropertyDescriptor("renderAs", FileWriterOperator.class,
						new String[] { "None", "Line", "CSV", "JSON", "XML" })
						.displayName("Render As")
						.description("")
						.optional()
						.setUIHints(
								UIHints.create().setTab("Adapter Properties")),
				new SBPropertyDescriptor("controlPort", FileWriterOperator.class)
						.displayName("Control Port")
						.description("")
						.optional()
						.setUIHints(
								UIHints.create().setTab("Adapter Properties")),
				new SBPropertyDescriptor("eventPort", FileWriterOperator.class)
						.displayName("Event Port")
						.description("")
						.optional()
						.setUIHints(
								UIHints.create().setTab("Adapter Properties")),
				new SBPropertyDescriptor("passthroughFields", FileWriterOperator.class)
						.displayName("Passthrough Fields")
						.description("")
						.optional()
						.setUIHints(
								UIHints.create().setTab("Adapter Properties")),

				// Line rendering options
				new SBPropertyDescriptor("oneLinePerTuple", FileWriterOperator.class)
						.displayName("One Line Per Tuple").description("")
						.optional()
						.setUIHints(UIHints.create().setTab("Line Options")),
				new SBPropertyDescriptor("lineSeparator", FileWriterOperator.class)
						.displayName("Line Separator").description("")
						.optional()
						.setUIHints(UIHints.create().setTab("Line Options")),
				new SBPropertyDescriptor("listTupleName", FileWriterOperator.class)
						.displayName("List Tuple Name").description("")
						.optional()
						.setUIHints(UIHints.create().setTab("Line Options")),

				// CSV Rendering Options
				new SBPropertyDescriptor("includeHeader", FileWriterOperator.class)
						.displayName("Include Header In File").description("")
						.optional()
						.setUIHints(UIHints.create().setTab("CSV Options")),

				new SBPropertyDescriptor("fieldDelimiter", FileWriterOperator.class)
						.displayName("Field Delimiter").description("")
						.optional()
						.setUIHints(UIHints.create().setTab("CSV Options")),
				new SBPropertyDescriptor("nullAsEmpty", FileWriterOperator.class)
						.displayName("Null As Empty").description("")
						.optional()
						.setUIHints(UIHints.create().setTab("CSV Options")),
				new SBPropertyDescriptor("nullValue", FileWriterOperator.class)
						.displayName("Null Value").description("").optional()
						.setUIHints(UIHints.create().setTab("CSV Options")),
				new SBPropertyDescriptor("timestampFormat", FileWriterOperator.class)
						.displayName("Timestamp Format").description("")
						.optional()
						.setUIHints(UIHints.create().setTab("CSV Options")),

		};
		return p;
	}

}
