import tensorflow as tf
import numpy as np
import pandas as pd
import pickle
from sklearn.preprocessing import LabelEncoder, OneHotEncoder, OrdinalEncoder

#model_path = 'c:/temp/'
#test_df = pickle.load(open(model_path + 'test_data.pkl','rb'))
scaler = pickle.load(open(model_path + 'scaler.pkl','rb'))
lstm_autoencoder_model = tf.keras.models.load_model(model_path + 'best_model.h5')
training_data = pickle.load(open(model_path + 'training_data.pkl','rb'))

def encode_column(data, training_data, this_encoder, reshape=False):
    #print(data.name)
    training_data = training_data[data.name].values
    data = data.values
    if reshape == True:
        training_data = training_data.reshape(-1,1)
        data = data.reshape(-1,1)

    this_encoder = this_encoder.fit(training_data)
    encoded_data = this_encoder.transform(data)
    if encoded_data.ndim == 2:
        encoded_data = encoded_data.reshape(len(encoded_data))
    return encoded_data

# Generated training sequences for use in the model
def create_sequences(data, lookback):
    output = []
    for i in range(len(data) - lookback + 1):
        output.append(data[i : (i + lookback), :])

    return np.stack(output)